// BGG wmm
extern "C" {
	extern void post(char *fmt, ...);
}


#include <rtcmix_types.h>
#include <utils.h>
#include <PField.h>
#include <string.h>		// for strcmp()
#include <stdlib.h>		// for free()

// NOTE:  For now, the Arg class does not reference and dereference the
// underlying Handle.  This is OK because Args are always temporary storage
// and their scope is always local within the parser.

Arg::~Arg() {
	if (_type == ArrayType) {
		if (_val.array->data)
			free(_val.array->data);
		free(_val.array);
	}
//	else if (_type == HandleType)
//		unrefHandle(_val.handle);
}

bool
Arg::operator == (const char *str) const {
	return isType(StringType) && !strcmp(_val.string, str);
}

void
Arg::operator = (const Handle h) {
	_type = HandleType;
	_val.handle = h;
//	refHandle(h);
}

void 
// BGG wmm -- changed this to take a buffer to fill, so we can use
//	post() from the calling function
//Arg::printInline(FILE *stream) const
Arg::printInline(char *tbuf) const
{
// BGG wmm -- also changed the fprintf to sprintf

	switch (type()) {
	case DoubleType:
//		fprintf(stream, "%g ", _val.number);
		sprintf(tbuf, "%g ", _val.number);
		break;
	case StringType:
//		fprintf(stream, "\"%s\" ", _val.string);
		sprintf(tbuf, "\"%s\" ", _val.string);
		break;
	case HandleType:
		if (_val.handle != NULL) {
			switch (_val.handle->type) {
			case PFieldType:
			{
				// Print PField start and end values.
				PField *pf = (PField *) _val.handle->ptr;
				double start = pf->doubleValue(0);
				double end = pf->doubleValue(1.0);
//				fprintf(stream, "PF:[%g,...,%g] ", start, end);
				sprintf(tbuf, "PF:[%g,...,%g] ", start, end);
				break;
			}
			case InstrumentPtrType:
//			fprintf(stream, "Inst:0x%x ", _val.handle->ptr);
			sprintf(tbuf, "Inst:0x%x ", _val.handle->ptr);
				break;
			case AudioStreamType:
//				fprintf(stream, "AudioStr:0x%x", _val.handle->ptr);
				sprintf(tbuf, "AudioStr:0x%x", _val.handle->ptr);
				break;
			default:
//				fprintf(stream, "Unknown ");
				sprintf(tbuf, "Unknown ");
				break;
			}
		}
		else
//			fprintf(stream, "NULL ");
			sprintf(tbuf, "NULL ");
		break;
	case ArrayType:
//		fprintf(stream, "[%g,...,%g] ", _val.array->data[0],
		sprintf(tbuf, "[%g,...,%g] ", _val.array->data[0],
				_val.array->data[_val.array->len - 1]);
		break;
	default:
		break;
	}
}

